#include <stdlib.mqh>
//+------------------------------------------------------------------+
//|                                            4 Hour Multi Pair.mq4 |
//|                                                                  |
//|                                                                  |
//|                                        Converted by Mql2Mq4 v1.1 |
//|                                            http://yousky.free.fr |
//|                                    Copyright  2006, Yousky Soft |
//+------------------------------------------------------------------+

#property copyright ""
#property link      ""


//+------------------------------------------------------------------+
//| Common External variables                                        |
//+------------------------------------------------------------------+
extern double Lots = 1.00;
extern double StopLoss = 30.00;
extern double TakeProfit = 80.00;
extern double TrailingStop = 30.00;

//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+
extern double slippage = 5;
extern double mm = 0;
extern double risk = 10;
extern double maxTradesPerPair = 1;

//+------------------------------------------------------------------+
//| Special Convertion Functions                                     |
//+------------------------------------------------------------------+

int LastTradeTime;

bool MOrderDelete( int ticket )
{
  LastTradeTime = CurTime();
  return ( OrderDelete( ticket ) );
}

bool MOrderModify( int ticket, double price, double stoploss, double takeprofit, datetime expiration, color arrow_color=CLR_NONE)
{
  LastTradeTime = CurTime();
  price = MathRound(price*10000)/10000;
  stoploss = MathRound(stoploss*10000)/10000;
  takeprofit = MathRound(takeprofit*10000)/10000;
  return ( OrderModify( ticket, price, stoploss, takeprofit, expiration, arrow_color) );
}

int MOrderSend( string symbol, int cmd, double volume, double price, int slippage, double stoploss, double takeprofit, string comment="", int magic=0, datetime expiration=0, color arrow_color=CLR_NONE)
{
  LastTradeTime = CurTime();
  price = MathRound(price*10000)/10000;
  stoploss = MathRound(stoploss*10000)/10000;
  takeprofit = MathRound(takeprofit*10000)/10000;
  return ( OrderSend( symbol, cmd, volume, price, slippage, stoploss, takeprofit, comment, magic, expiration, arrow_color ) );
}

int OrderValueTicket(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderTicket());
}

int OrderValueType(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderType());
}

double OrderValueLots(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderLots());
}

double OrderValueOpenPrice(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderOpenPrice());
}

double OrderValueStopLoss(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderStopLoss());
}

double OrderValueTakeProfit(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderTakeProfit());
}

double OrderValueClosePrice(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderClosePrice());
}

string OrderValueSymbol(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderSymbol());
}

bool IsIndirect(string symbol)
{
  return(False);
}

//+------------------------------------------------------------------+
//| End                                                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+

int init()
{
   return(0);
}
int start()
{
//+------------------------------------------------------------------+
//| Local variables                                                  |
//+------------------------------------------------------------------+
double CurrentTrades = 0;
int cnt = 0;
double lotsi = 0;
double a1 = 0;
double b1 = 0;
double askb = 0;
double bids = 0;
bool AccountIsMini = False;
double Totaltrades = 0;
/*[[
    Name := 4 Hour Expert
    Update on every tick := Yes
    Enable Alerts := Yes
    Disable alert once hit := No
    Lots := 1.00
    Stop Loss := 30
    Take Profit := 80
    Trailing Stop := 30
]]*/

if( TimeYear(Time)<2006 ) return(0);
if( MathAbs(High[1]-Low[1])<(22*Point)) return(0);
//If FreeMargin<1000 Then Exit;
if( CurTime() - LastTradeTime < 300 ) return(0);
if( IsIndirect(Symbol()) == True ) return(0);

if( TrailingStop<5 ) {
   Print("Invalid trailing stop");return(0);}







a1=Ask+5*Point;
b1=Bid-5*Point;
askb=Ask+10*Point;
bids=Bid-10*Point;


AccountIsMini = False; 
if( mm != 0 ) {
   lotsi=MathCeil(AccountBalance()*risk/10000)/10;
if( lotsi>1 ) {
   lotsi=MathCeil(lotsi);}
if( lotsi>100 ) {
   lotsi=100;}}
 else {lotsi=Lots;}

// ====================================================================================================
// OPEN ORDER CHECK -
// Each instance of a script is attached to one currency pair.
// When this check executes, it sets CurrentTrades to 1 so that
// only one trade for this symbol will be open, which is enforced
// by "if CurrentTrades = 0".
// ====================================================================================================

CurrentTrades = 0;

for(cnt =1;cnt <=OrdersTotal();cnt ++)
{ 
  if( OrderValueSymbol(cnt) == Symbol() ) 
  {
    CurrentTrades = CurrentTrades + 1;
  }
}

// ====================================================================================================
// TRADE ENTRY
// ====================================================================================================

if( CurrentTrades < maxTradesPerPair ) 
{
if( (b1<Low[1])) {
   MOrderSend(Symbol(),OP_SELLSTOP,lotsi,bids,slippage,bids+StopLoss*Point,bids-TakeProfit*Point,"",16384,0,Gold);return(0);}
if( (a1>High[1])) {
   MOrderSend(Symbol(),OP_BUYSTOP,lotsi,askb,slippage,askb-StopLoss*Point,askb+TakeProfit*Point,"",16384,0,White);return(0);}}

for(cnt=1;cnt<=Totaltrades;cnt++){
if( (b1<Low[1])) {
if( OrderValueSymbol(cnt) == Symbol() && OrderValueType(cnt) == OP_BUY ) 
   OrderClose(OrderValueTicket(cnt),OrderValueLots(cnt),OrderValueClosePrice(cnt),slippage,White)
; else if( OrderValueType(cnt) == OP_BUYSTOP ) 
		MOrderDelete(OrderValueTicket(cnt));}
if( (a1>High[1])) {
if( OrderValueSymbol(cnt) == Symbol() && OrderValueType(cnt) == OP_SELL ) 
   OrderClose(OrderValueTicket(cnt),OrderValueLots(cnt),OrderValueClosePrice(cnt),slippage,Gold)
; else if( OrderValueType(cnt) == OP_SELLSTOP ) 
		MOrderDelete(OrderValueTicket(cnt));}}

for(cnt=1;cnt<=Totaltrades;cnt++){
if( OrderValueSymbol(cnt) == Symbol() && OrderValueType(cnt) == OP_BUY ) {
if( OrderValueStopLoss(cnt)<(Bid-TrailingStop*Point) ) {
   MOrderModify(OrderValueTicket(cnt),OrderValueOpenPrice(cnt),
   Bid-TrailingStop*Point,OrderValueTakeProfit(cnt),0,White);return(0);}}
if( OrderValueType(cnt) == OP_SELL ) {
if( OrderValueStopLoss(cnt)>(Ask+TrailingStop*Point) || OrderValueStopLoss(cnt) == 0 ) {
   MOrderModify(OrderValueTicket(cnt),OrderValueOpenPrice(cnt),
   Ask+TrailingStop*Point,OrderValueTakeProfit(cnt),0,Gold);return(0);}}}  return(0);
}